<template>
<nav class="navbar fixed-top navbar-expand-lg navbar-light bg-light">
    <div class="container">
            <a class="navbar-brand" href="#">BLOGS MILENNIAL</a>
        <button class="navbar-toggler" 
                type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
               <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarNav">
            <ul class="navbar-nav mr-auto">
                <li class="nav-item">
                    <router-link exact class="nav-link mr-3 ml-5" to="/">Home</router-link>
                </li>
                <li class="nav-item">
                    <router-link class="nav-link mr-3" to="/blogs">Blogs</router-link>
                </li>
                <li class="nav-item">
                    <router-link class="nav-link mr-3" to="/about">About</router-link>
                </li>
            </ul>
            <ul class="navbar-nav"> 
                <template v-if="!authCheck">   
                    <li class="nav-item">
                        <router-link class="nav-link btn btn-success mr-3 px-3 py-2 text-white border-0" 
                                    :to="{ name: 'auth.Login'}">
                                    Login
                        </router-link>
                    </li>   
                    <li class="nav-item">
                        <router-link class="nav-link mr-3 btn btn-primary px-3 py-2 text-white border-0" 
                                    :to="{ name: 'auth.Register'}">
                            Register
                        </router-link>
                    </li>
                </template>
                <template v-else>
                     <li class="nav-item dropdown">
                        <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        Hai, <strong> {{ user.name }} </strong> 
                        </a>
                        <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                            <a class="dropdown-item" href="#" @click.prevent="logout">Logout</a>  
                            <router-link class="dropdown-item" :to="{ name: 'Store'}">
                                Kelola
                            </router-link>                       
                        </div>
                    </li>   
                    <li>
                        <img :src="user.photo_profile ?  photoDomain + user.photo_profile : 'https://randomuser.me/api/portraits/men/81.jpg' "
                            class="rounded-circle" 
                            alt=""
                            style="height:50px; width:50px;">        
                    </li>
                </template>           
            </ul>
        </div>
    </div>        
</nav>
</template>

<script>
import { mapGetters, mapActions } from 'vuex'
import swal from 'sweetalert';
import axios from 'axios'

export default {
    name: 'Header',
    data: () => ({      
        photoDomain : 'https://demo-api-vue.sanbercloud.com',
    }),

    computed: {
        ...mapGetters({
            authCheck:'auth/check',
            user:'auth/user',
            token:'auth/token',
        })
    },

    methods: {
        ...mapActions({
            // signoutAction:'auth/signout',
            CHECKTOKEN: 'auth/CHECKTOKEN',
            setToken: 'auth/SET_TOKEN',
            setUser: 'auth/SET_USER',
            setAuthenticated: 'auth/SET_AUTHENTICATED'
        }),

        // async logout () {
        //     await this.signoutAction()
        //     .then(() => location.href = '/')
        //     // this.$router.replace('/login')
        // }

        async logout () {
            let config = {
                method: 'post',
                url : 'https://demo-api-vue.sanbercloud.com/api/v2/auth/logout',
                headers: {
                    'Authorization' : 'Bearer ' + this.token,
                },
            }       
        
        await axios(config) 
            .then(() => {  
                this.setToken('')
                this.setUser([])
                this.setAuthenticated(false)
                // this.SET_AUTHENTICATED(false)
                // this.$router.replace('/')
                // location.reload();
                // this.authCheck = false
                swal({
                    title: "Anda Berhasil Logout",
                    button: "Close",
                    timer: 2000,
                });
                // this.$router.push('/');       
            })
            .catch( (response) => {
                console.log(response)
                // swal({
                //     title: "gagal logout",
                //     button: "Close",
                //     timer: 2000,
                // });
            });
            // .then(() => location.href = '/')
            // this.$router.replace('/login')
        }
    },

    mounted() {
        // console.log(this.user)
        // this.logout()
    },
}
</script>

<style scoped>
    nav ul li a{
        font-size: 16px !important;
    }

    nav {
        height: 80px !important;
    }

    .navbar-brand {
        font-size: 18px !important;
    }
</style>



